SystemOrganization addCategory: #'GBT-DSL_EFA'!

Object subclass: #EFA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

EFA subclass: #Auswertungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Auswertungen methodsFor: 'as yet unclassified' stamp: 'hk 1/28/2018 14:21'!
contexts

^'plain Auswertungen of FahrtContext{
	displayAs	: Auswertungen
	icon	: #beitragsMgmt16
	uiSpec	: #GbtListAndItemUI
	pool	: 
	templates	: FahrtContext
	loadPolicy	: #autoload
	subcontexts	: FahrtContext
	legalText	: 
	behaviors	: 
	onCreate	: 
	}'! !

!EFA class methodsFor: 'example' stamp: 'hk 1/9/2018 14:11'!
exampleRun
	GbtServer  initialize: #EFA; clearStore: #EFA. 
	self installUsers.
	Boote new ensureCompilation; storeBoote.
	Personen new ensureCompilation; storePersonen.
	Fahrtenbuch new ensureCompilation; storeTestFahrten.		"needs Boote"
	Beitragsmanagement new ensureCompilation.
	Beitragstabellen new ensureCompilation; storeBeitragstabellen.
	Beitragsabrechnung new ensureCompilation.
	Rechnungen new ensureCompilation.
	OPListen new ensureCompilation.
	Statistics new ensureCompilation.
	(self new 
		ensureCompilation ;
		loginContext) ui 
			title: #Login; 
			open! !

!EFA class methodsFor: 'example' stamp: 'hk 8/16/2017 17:15'!
installUsers
		#(Tom Lisa) do: [:u| GbtServer default addUser: u withRole: GbtRole forExecute ].
		#(Tony Robert) do: [:u| GbtServer default addUser: u withRole: GbtRole forWrite ].
		#(Bob) do: [:u| GbtServer default addUser: u withRole: GbtRole forRead ]! !

!EFA methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:08'!
eFA
	^'
plain EFA {
	displayAs	: EFA
	icon	: efa
	uiSpec	: GbtMainUI
	windowSize	: 1200@800
	subcontexts	: FahrtenBuchContext BooteContext PersonenContext BeitragsmanagementContext StatisticsContext 
	legalText	: GloConn International © 2018
	}
'! !

!EFA methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:08'!
eFALogin
	^'
	plain EFALogin {
	displayAs	: EFA
	icon	: efa
	uiSpec	: GbtLoginUI
	subcontexts	: EFA Login
	legalText	: GloConn International © 2018
	}
'! !

!EFA methodsFor: 'compile' stamp: 'hk 1/27/2018 16:50'!
ensureCompilation
	"sort of incremental ..."
	| compiler |
	compiler := GbtCompiler new.    
	{self things . self projectors } do: [:sources | 
		compiler parse: sources onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]].
	(self class selectorsInProtocol: #contexts)  do: [:mtd | |sources| 
		sources := self perform: mtd.
		compiler parse: sources onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]].! !

!EFA methodsFor: 'compile' stamp: 'hk 1/27/2018 16:37'!
loginContext 
	^GbtSmartContext definedAs: 'EFALogin' 
! !

!EFA methodsFor: 'functions' stamp: 'hk 1/27/2018 16:50'!
projectors
	^''! !

!EFA methodsFor: 'things' stamp: 'hk 11/7/2017 20:20'!
things
	^''! !

EFA subclass: #Fahrtenbuch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Fahrtenbuch class methodsFor: 'examples' stamp: 'hk 12/31/2017 19:11'!
exampleRun
	GbtServer clearStore; initialize. 
	Boote new ensureCompilation; storeBoote.
	(self new 
		ensureCompilation ; 
		storeTestFahrten ; 
		fahrtenBuchContext) ui 
			title: #Fahrtenbuch; 
			open! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:36'!
fahrt
	^GbtSmartNode copy: 'Fahrt'! !

!Fahrtenbuch methodsFor: 'contexts' stamp: 'hk 1/27/2018 17:31'!
fahrtContext
	^ '	plain FahrtContext {
		subcontexts 	: 	BuddyWallet 
		uiSpec 		: 	GbtItemUI 
		icon 			: 	rowingTeam
		displayAs 	: 	Fahrt
		onExpand 		:  Boot chooseBoat
		onExpand 		: 	Steuermann choosePerson   
		onExpand 		: 	Mannschaft choosePerson
		legalText 	: 	GloConn International © 2018
		behaviors 	:  chooseBoat choosePerson
		}
	behavior chooseBoat  { 
		chooseBoat 		:  askContext(BooteContext)
		}
	behavior choosePerson  { 
		person 			:  askContext(PersonenContext)
		choosePerson 	:  transform( RudererProjector person)
		}
	'! !

!Fahrtenbuch methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:08'!
fahrtenBuchContext
	^ '	
	primeList FahrtenBuchContext of Fahrt {  
	 	displayAs 	: 	FahrtenBuch
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	rowingTeam
		loadPolicy 	: 	autoload 
		listColumns 	: 	(Bootsname Boot) (RudererName Steuermann) Abfahrt 
		listPrefix 	: 	Fahrt 
		subcontext 	: 	FahrtContext 
		}
	'! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:03'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #FahrtenBuchContext! !

!Fahrtenbuch methodsFor: 'functions' stamp: 'hk 1/27/2018 17:37'!
projectors
	^'
	projector RudererProjector  {
		tag RudererName : Nachname 
		tag RudererVorname : Vorname 
		tag SportlerId : bizId 
		FremdVerein  
		}	
	'
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:36'!
ruderer
	^GbtSmartNode copy: 'Ruderer'! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 12/31/2017 19:11'!
storeTestFahrten
	self testFahrt1 storeSubtree.
	self testFahrt2 storeSubtree.
	self testFahrt3 storeSubtree.
	self testFahrt4 storeSubtree.
	self testFahrt5 storeSubtree.
	self testFahrt6 storeSubtree! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:46'!
testFahrt1
	^self fahrt 
		bizId: self nextBizID;
		Bootsname: 'Alster';
		Steuermann: self testRuderer1;
		Kilometer: 20;
		yourself
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:45'!
testFahrt2
	^self fahrt 
		bizId: self nextBizID;
		Bootsname: 'Alster';
		Steuermann: self testRuderer2;
		Kilometer: 28;
		yourself
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:46'!
testFahrt3
	^self fahrt 
		bizId: self nextBizID;
		Bootsname: 'Alster';
		Steuermann: self testRuderer3;
		Kilometer: 30;
		yourself
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:46'!
testFahrt4
	| aFahrt |
	aFahrt := self fahrt 
		bizId: self nextBizID;
		Bootsname: 'Elbe';
		Steuermann: self testRuderer3;
		Kilometer: 99;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer1 .
	^aFahrt

! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:46'!
testFahrt5
	| aFahrt |
	aFahrt := self fahrt 
		bizId: self nextBizID;
		Bootsname: 'Elbe';
		Steuermann: self testRuderer3;
		Kilometer: 77;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer2.
	^aFahrt
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:46'!
testFahrt6
	| aFahrt |
	aFahrt := self fahrt 
		bizId: self nextBizID;
		Bootsname: 'Elbe';
		Steuermann: self testRuderer3;
		Kilometer: 66;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer3.
	^aFahrt 

! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:46'!
testRuderer1
	^self ruderer
		RudererName: 'Schmidt1'; 
		RudererVorname: 'Henning';
		yourself! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:47'!
testRuderer2
	^self ruderer
		RudererName: 'Schmidt2';
		RudererVorname: 'Henning';
		yourself! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 2/23/2018 20:47'!
testRuderer3
	^self ruderer
		RudererName: 'Schmidt3';
		RudererVorname: 'Henning';
		yourself! !

!Fahrtenbuch methodsFor: 'things' stamp: 'hk 2/25/2018 13:05'!
things
	^ '	thing Besatzung 
		summary 				:  system template
		{ 
		*node Steuermann 	:  Ruderer
		*list Mannschaft 	:  Ruderer
		}
	thing Fahrt
		summary 				:  ''#bizId : #Besatzung:RudererName #Mannschaft ab: #Abfahrt an: #Ankunft''
		bizIdPolicy 			: FahrtNoPolicy
		{ 
		*val Datum  		: date(today)
		*node Boot 			: Boot 
		*node Besatzung 	: Besatzung 
		*val Abfahrt  		: date(1 July 2016)
		*val Ankunft  		: date(2 July 2016)
		*val Ziel 	 		: Fluss | Mündung {ui: GbtChoiceWidget}
		*val Kilometer		: 0
		text Bemerkung 		:
		val FahrtArt 		: Normale Fahrt | Trainingsfahrt | Wanderfahrt {ui: GbtChoiceWidget}
		}				
	thing Ruderer
		summary 				: ''#RudererName , #RudererVorname''
		purposes 				: Steuermann Ruderer
		{  
		*val RudererName	:  
		*val RudererVorname:  
		*val SportlerId 	:  
 		val FremdVerein 	:  
		}
'! !

EFA subclass: #Finanzen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Finanzen subclass: #Beitragsabrechnung
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsabrechnung commentStamp: 'hk 11/7/2017 11:54' prior: 0!
Implementation Points

does not work without Beitragstabellen!

!Beitragsabrechnung class methodsFor: 'example' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	Beitragstabellen new ensureCompilation.
	(self new 
		ensureCompilation ;
		beitragsabrechnungenContext) ui 
			title: #Beitragsabrechnungen; 
			open! !

!Beitragsabrechnung methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:05'!
beitragContext

^'
plain BeitragContext {
	displayAs	: Beitrag
	icon	: beitragsMgmt16
	uiSpec	: GbtItemUI
	}
'! !

!Beitragsabrechnung methodsFor: 'contexts' stamp: 'hk 1/28/2018 14:21'!
beitragsabrechnungContext

^'
plain BeitragsabrechnungContext {
	displayAs		: Beitragsabrechnung
	icon			: beitragsMgmt16
	uiSpec			: GbtItemWithTabsUI
	pool 		 	: BeitragDir
	subcontexts	: BeitragslisteContext 
	menu			: BeitraegsMenu Abrechnung Einbuchen
	onExpand 		: Beitragstabelle chooseB
	behaviors		: Abrechnung chooseB
	}
behavior chooseB { 
	chooseB :  askContext(BeitragstabellenContext)
	}				
behavior Abrechnung { 
	personen 			:  PersonenContext:list 
	tabelle			:  contextThing:Beitragstabelle
	beitragsliste 	:  transform(BeitragDir personen  tabelle	)
	beitraege			:  freeze (beitragsliste)		
	Abrechnung 		:  contextThing:Beitragsliste := nodeList(beitraege)
	}
'! !

!Beitragsabrechnung methodsFor: 'compile' stamp: 'hk 1/27/2018 16:37'!
beitragsabrechnungenContext 
	^GbtSmartContext definedAs: 'BeitragsabrechungenContext' ! !

!Beitragsabrechnung methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:06'!
beitragsabrechungenContext

^'
primeList BeitragsabrechungenContext  of Beitragsabrechnung {
	displayAs		: Beitragsabrechnungen
	icon			: beitragsMgmt16
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (BeitragssummeGesamt Summe)(AnzahlMitglieder Mitglieder)(AnzahlVollzahler Vollzahler)(AnzahlRabattierteMitglieder rabattiert)
	listPrefix	: Abrechnung
	subcontext	: BeitragsabrechnungContext
	}
'! !

!Beitragsabrechnung methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:07'!
beitragslisteContext

^'
uList BeitragslisteContext  of Beitrag {
	displayAs	: Beitragsliste
	icon	: beitragsMgmt16
	uiSpec	: GbtListAndItemUI
	listColumns	: Nachname Vorname Betrag 
	subcontext	: BeitragContext
	elderSlot 	: Beitragsliste
	}
'! !

!Beitragsabrechnung methodsFor: 'functions' stamp: 'hk 1/27/2018 17:21'!
projectors
	^ 'projector BeitragDir {
	Berechnungsdatum
	Nachname
	Vorname
	tag Mitgliedsnummer : bizId
	FamilienOberhaupt
	Mitgliedstatus
	Beitragstatus
	Familienname
	FamilienNummer
	FamilienmitgliedNr
	aktiv
	passiv
	Familienrabatt
	Mindestbeitrag
	normalBeitrag
	ermBeitrag
	beitrag
	Betrag
	Währung
	tag vz : vollzahler
	tag rz : rabattiert
	tag az : anzahl
	Rechnungserzeugung
	Fälligkeit
	}
'! !

!Beitragsabrechnung methodsFor: 'things' stamp: 'hk 2/25/2018 13:22'!
things
	^ '
thing Abrechnungszeitraum
	summary	: system template
	{
	*val Von	: date(3 November 2017)
	*val bis	: date(3 November 2017)
	}
thing Beitrag
	summary	: #Nachname #Vorname EUR #Betrag
	{
	*val Berechnungsdatum	: date(3 November 2017)
	*val Nachname	: 
	*val Vorname	: 
	*val Mitgliedsnummer	: 
	*val FamilienOberhaupt	: false 
	*val Mitgliedstatus	: aktiv | passiv {ui: GbtChoiceWidget}
	*val Beitragstatus	: Erwachsener | Nichtverdiener14plus | Kind14minus {ui: GbtChoiceWidget}
	*val Familienname	: 
	*val FamilienmitgliedNr	: 1
	*val normalBeitrag	: 0
	*val Familienrabatt	: 0
	*val Mindestbeitrag	: 0
	*val ermBeitrag	: 0
	*val beitrag	: 0
	*val Betrag	: 0
	*val Währung	: EUR
	*val vz	: 
	*val rz	: 
	*val az	: 1
	*val Rechnungserzeugung	: false | true {ui: GbtChoiceWidget}
	*val Fälligkeit	: date(3 November 2017)
	}
thing Beitragsabrechnung
	summary	: #Abrechnungsname #BeitragssummeGesamt
	bizIdPolicy	: BeitragsAbrechnungsNoPolicy
	{
	*val Abrechnungsgenauigkeit	: Tag | Monat | Halbjahr | Jahr {ui: GbtChoiceWidget}
	*val Abrechnungsname	: 
	*node Abrechnungszeitraum	: Abrechnungszeitraum
	node Beitragstabelle	: HKBeitragstabelle
	*val Abrechner	: 
	*list Beitragsliste	: Beitrag 
	*val BeitragssummeGesamt	: sumTag (beitrag)
	*val AnzahlVollzahler	: sumTag (vz)
	*val AnzahlRabattierteMitglieder	: sumTag (rz)
	*val AnzahlMitglieder	: sumTag (az)
	}
 '! !

Finanzen subclass: #Beitragsmanagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsmanagement commentStamp: 'hk 11/9/2017 12:07' prior: 0!
Implementation Points

Construction problem: 

Beitragsmanagement has 4 Ulists:
- Beitragstabellen 
- Beitragsabrechnung
- Rechnungen
- opListen 
However, the subcontexts for these Ulists in Beitragsmanagement are primeLists.

As such, the list elements are never stored in the Ulists .....!

!Beitragsmanagement class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:15'!
exampleRun
	GbtServer clearStore; initialize. 
	Beitragstabellen new ensureCompilation; storeBeitragstabellen.
	Beitragsabrechnung new ensureCompilation.
	Rechnungen new ensureCompilation.
	OPListen new ensureCompilation.
	(self new 
		ensureCompilation ;
		beitragsmanagementContext) ui 
			title: #Beitragsmanagement; 
			open! !

!Beitragsmanagement methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:05'!
beitragsmanagementContext
^'
plain BeitragsmanagementContext  on Beitragsmanagement  {
	displayAs	: Beitragsmanagment
	icon	: beitragsMgmt16
	uiSpec	: GbtItemWithTabsUI
	subcontexts	: VorjahreContext BeitragstabellenContext BeitragsabrechungenContext RechnungenContext opListenContext
	menu	: Beitragsmanagement DoSomething1 DoSomething2
	}	'! !

!Beitragsmanagement methodsFor: 'functions' stamp: 'hk 1/27/2018 16:50'!
projectors
^''! !

!Beitragsmanagement methodsFor: 'things' stamp: 'hk 2/25/2018 13:04'!
things
	^ '	
thing Beitragsmanagement
	{
	*val AktuellerAbrechnungszeitraum	: 
	*val OffeneBeitraege					: 0
	*list VorjahresSummen 				: VorjahresSumme
	}	
thing VorjahresSumme
	{
	*val Jahr 	: 
	*val Summe		: 
	}	
 '! !

!Beitragsmanagement methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:05'!
vorjahreContext
^'
plain VorjahreContext  on VorjahresSumme {
	displayAs	: Vorjahre
	icon	: beitragsMgmt16
	uiSpec	: GbtAspectUI
	elderSlot	: VorjahresSummen 
	}	'! !

Finanzen subclass: #Beitragstabellen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragstabellen class methodsFor: 'example' stamp: 'hk 11/8/2017 15:13'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		storeBeitragstabellen;
		beitragstabellenContext) ui 
			title: #Beitragstabellen; 
			open! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:06'!
beitragsTabelle
	^GbtSmartNode copy: 'HKBeitragstabelle'! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 2/24/2018 19:48'!
beitragsTabelle2016 
	^self beitragsTabelle 
		TabellenName: '''Jahr_2016''' ;
		GueltigkeitVon: 'date(01.01.2016)' ;
		GueltigkeitBis: 'date(12.31.2016)';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: 'date(03.02.2016)';	
		Abrechnungsmodus: 'GanzjahresAbrechnung'	;
		yourself
! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 2/24/2018 19:48'!
beitragsTabelle2016HJ1 
	^self beitragsTabelle 
		TabellenName: '''1.HJ_2016''' ;
		GueltigkeitVon: '''01.01.2016''' ;
		GueltigkeitBis: '''06.30.2016''';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '''03.02.2016''';		
		yourself! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 2/24/2018 19:48'!
beitragsTabelle2016HJ2
	^self beitragsTabelle 
		TabellenName: '''2.HJ_2016''' ;
		GueltigkeitVon: '''07.01.2016''' ;
		GueltigkeitBis: '''12.31.2016''';
		Mindestbeitrag: 80.00 ;		
		Familienrabatt: 0.4;		
		BeschlossenAm: '''03.02.2016''';		
		yourself! !

!Beitragstabellen methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:04'!
beitragstabelleContext
^'
plain BeitragstabelleContext {
	displayAs	: Beitragstabelle
	icon	: beitragsMgmt16
	uiSpec	: GbtItemUI
	}
	'
! !

!Beitragstabellen methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:04'!
beitragstabellenContext
^'
primeList BeitragstabellenContext  of HKBeitragstabelle {
	displayAs	: Beitragstabellen
	icon	: bizoffer16
	uiSpec	: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (TabellenName Name)(GueltigkeitVon von)(GueltigkeitBis bis)
	listPrefix	: BT
	subcontext	: BeitragstabelleContext
	}
	'
! !

!Beitragstabellen methodsFor: 'functions' stamp: 'hk 1/27/2018 16:50'!
projectors
	^ ''! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:04'!
storeBeitragstabellen
	self beitragsTabelle2016 storeSubtree.
	self beitragsTabelle2016HJ1 storeSubtree.
	self beitragsTabelle2016HJ2 storeSubtree! !

!Beitragstabellen methodsFor: 'things' stamp: 'hk 2/25/2018 13:21'!
things
	^ '
thing BasisBeitragAktiv
	summary	: system template
	{
	*val Erwachsener	: 230
	*val Nichtverdiener14plus	: 135
	*val Kind14minus	: 100
	}
thing BasisBeitragPassiv
	summary	: system template
	{
	*val Erwachsener	: 115
	*val Nichtverdiener14plus	: 115
	*val Kind14minus	: 115
	}
thing BeitragXLS
	summary	: system template
	{
	*node aktiv	: FBasisBeitragAktiv {tags: aktiv }
	*node passiv	: FBasisBeitragPassiv {tags: passiv }
	*val Währung	: EUR
	*val Mindestbeitrag	: 70.0
	*val Familienrabatt	: 0.5
	*val normalBeitrag	: lookup (Mitgliedstatus Beitragstatus)
	*val ermBeitrag	:  if ( #FamilienmitgliedNr = 2 ; #normalBeitrag * #Familienrabatt ; #Mindestbeitrag )
	*val beitrag	:  if ( #FamilienOberhaupt ; #normalBeitrag ; #ermBeitrag )
	*val Betrag	:  max ( #beitrag ; #Mindestbeitrag  )
	*val vollzahler	:  if ( #Betrag = #normalBeitrag ; 1 ; 0 )
	*val rabattiert	:  if ( #Betrag = #normalBeitrag ; 0 ; 1 )
	*val anzahl	: 1
	}
thing HKBeitragstabelle
	summary	: #TabellenName : #GueltigkeitVon - #GueltigkeitBis 
	bizIdPolicy	: BeitragsTabelleNoPolicy
	{
	*val TabellenName	: 
	*val GueltigkeitVon	: date(6 November 2017)
	*val GueltigkeitBis	: date(6 November 2017)
	*val Abrechnungsmodus	: HalbjahresAbrechnung | GanzjahresAbrechnung {ui: GbtChoiceWidget}
	*node BeitragXLS	: FBeitragXLS
	*val BeschlossenAm	: date(6 November 2017)
	*val BeschlossenDurch	: Hauptversammlung | Sonderregelung {ui: GbtChoiceWidget}
	}
	'! !

Finanzen subclass: #OPListen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!OPListen class methodsFor: 'example' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		opListenContext) ui 
			title: #OP_Listen; 
			open! !

!OPListen methodsFor: 'contexts' stamp: 'hk 1/26/2018 13:56'!
opListeContext
^'
plain opListeContext {
	displayAs		: OPListe
	icon			: beitragsMgmt16
	uiSpec			: GbtItemUI
	behaviors		:  % Mahnungen verschicken
	menu 			: % Mahnungen verschicken undso
	onCreate 		:  % undSo
	templates 	: % keine
	subcontexts 	: % keine
	}
'
! !

!OPListen methodsFor: 'as yet unclassified' stamp: 'hk 1/27/2018 16:37'!
opListenContext 
	^GbtSmartContext definedAs: 'opListenContext' 
! !

!OPListen methodsFor: 'contexts' stamp: 'hk 1/28/2018 14:22'!
opListenContextSource
^'
primeList opListenContext  of opListe {
	displayAs		: OPListen
	icon			: bizoffer16
	uiSpec			: GbtListAndItemUI
	loadPolicy	: % autoload
	pool 			:  % empty
	listPrefix 	: OP
	listColumns	: (bizId Rechnungsnummer)(Rechnungsbeitrag Beitrag)
	subcontext	: opListeContext
	elderSlot 	:  % nil
	}
'! !

!OPListen methodsFor: 'functions' stamp: 'hk 1/27/2018 16:50'!
projectors
	^''! !

!OPListen methodsFor: 'things' stamp: 'hk 2/25/2018 13:06'!
things
	^ '
thing opListe
	summary	: #bizId #Berechnungsdatum EUR #Beitragshöhe
	bizIdPolicy	: OPListeNoPolicy
	{
	*val Bezeichnung	: 
	*val Erstellung	: Rechnung  | Storno {ui: GbtChoiceWidget}
	*list OPListeAktuell	: Rechnung 
	*val OPSumme	: 0
	}
'! !

Finanzen subclass: #Rechnungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Rechnungen class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		rechnungenContext) ui 
			title: #Rechnungsn; 
			open! !

!Rechnungen methodsFor: 'functions' stamp: 'hk 1/27/2018 17:22'!
projectors
	^ '
projector DirRechnungBeitrag {
	Berechnungsdatum
	Nachname
	Vorname
	Mitgliedsnummer
	Familienname
	FamilienNummer
	FamilienmitgliedNr
	Betrag
	Währung
	AdressatNummer
	}
projector DirRechnungsadresse {
	tag AdressatName : Nachame
	tag AdressatVorname : Vorname
	StraßeUndNummer
	PLZUndWohnort
	}
projector DirRechnungsposition {
	Nachname
	Vorname
	Mitgliedsnummer
	tag AbrechnungVon : Berechnungsdatum
	AbrechnungBis
	Betrag
	Währung
	}
'! !

!Rechnungen methodsFor: 'contexts' stamp: 'hk 1/28/2018 14:22'!
rechnungContext
	^ '	
plain RechnungContext  {
	displayAs		: Rechnung
	icon			: beitragsMgmt16
	uiSpec			: GbtItemUI
	pool 			: DirRechnungsposition DirRechnungBeitrag FamilienConstraint
	behaviors		: rgPositionen
	}
behavior rgPositionen  
	arg1 	 			:     	% Beitragsabrechnung eines Oberhaupts
	arg2 				:     % alle Beitragsabrechnungen
	{
	neueRechnung 	: newContextThing
	RgMitAdressat	: neueRechnung:AdressatNummer := arg1:Mitgliedsnummer
	oberhauptPos		: transform ( DirRechnungsposition arg1)	
	rechnung 			: append(RgMitAdressat:Rechnungspositionen oberhauptPos)
	liste2 			: transform (DirRechnungBeitrag freeze(arg2)  RgMitAdressat)
	liste1 			: filter (liste2 FamilienConstraint)  % filter auf Adressat
	liste 				: transform ( DirRechnungsposition liste1)
	rgPositionen 	: append (rechnung:Rechnungspositionen liste)
	}
 '
! !

!Rechnungen methodsFor: 'contexts' stamp: 'hk 1/28/2018 14:23'!
rechnungenContext
	^ '	
primeList RechnungenContext  of Rechnung {
	displayAs		: Rechnungen
	icon			: bizoffer16
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	pool 			: OberhauptConstraint 
	listColumns	: (AdressatNummer Mitgliedsnummer)(Rechnungsbeitrag Beitrag)
	listPrefix	: Rng
	subcontext	: RechnungContext
	menu			: Rechnungslauf 
	menu			: neueRechnung
	behaviors		: Rechnungslauf neueRechnung
	}
behavior Rechnungslauf { 
	abrechnung 		: askContext(BeitragsabrechungenContext)
	liste 				: abrechnung:Beitragsliste:list
	oberhaeupter 	: filter(liste OberhauptConstraint)
	behPos				: RechnungContext:rgPositionen
	Rechnungslauf 	: applyOnList(behPos oberhaeupter liste)
	}
behavior neueRechnung { 
	abrechnung 		: askContext(BeitragsabrechungenContext)
	liste 				: abrechnung:Beitragsliste:list
	adressat 			: askUser (liste)		
	behPos				: RechnungContext:rgPositionen
	neueRechnung 			: apply(behPos adressat liste)
	}
 '
! !

!Rechnungen methodsFor: 'things' stamp: 'hk 2/25/2018 13:11'!
things
	^ '
thing FamilienConstraint
	{
	*constraint mitglied	: #FamilienmitgliedNr > 1
	*constraint familie	: #FamilienNummer = #AdressatNummer
	}
thing OberhauptConstraint
	{
	*constraint mitglied	: #FamilienmitgliedNr = 1
	}
thing Rechnung
	summary							: #bizId #Berechnungsdatum EUR #Beitragshöhe
	bizIdPolicy						: RechnungNoPolicy
	{
	*val Rechnungstyp				: Rechnung | Storno {ui: GbtChoiceWidget}
	*val Rechnungsdatum			: date(3 November 2017)
	*val Rechnungskopf				: Absender aus Vereinsstammdaten
	*node Rechnungsadresse		: FRechnungsadresse
	*list Rechnungspositionen	: Rechnungsposition
	*val Rechnungsbeitrag			: sumTag (Betrag)
	val Eingebucht					: false | true {ui: GbtChoiceWidget}
	val Buchungsdatum				: date(3 November 2017)
	val Fälligkeit					: date(3 November 2017)
	}
thing Rechnungsadresse
	summary					: system template
	{
	*val AdressatNummer	: bizId
	*val AdressatName		: 
	*val AdressatVorname	: 
	*val StraßeUndNummer	: 
	*val PLZUndWohnort		: 
	}
thing Rechnungsposition
	summary					: #Betrag #Währung : #Nachname #Vorname 
	{
	*val Nachname			: 
	*val Vorname				: 
	*val Mitgliedsnummer	: 
	*val AbrechnungVon	: date(3 November 2017)
	*val AbrechnungBis	: date(3 November 2017)
	*val Betrag				: 0
	*val Währung				: EUR
	}		
'! !

EFA subclass: #Kommunikation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

EFA subclass: #Stammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Boote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Boote class methodsFor: 'example' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		storeBoote ;
		booteContext) ui 
			title: #Boote; 
			open! !

!Boote methodsFor: 'test data' stamp: 'hk 10/17/2017 16:33'!
boot
	^GbtSmartNode copy: 'Boot'! !

!Boote methodsFor: 'test data' stamp: 'hk 2/28/2018 13:04'!
boot01
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Wisch' ;	
		Bootstyp: 'Einer';
		MannschaftAnzahlMax: 1;	
		Steuermann: 'ohne';
		Baujahr: 2001;
		yourself

! !

!Boote methodsFor: 'test data' stamp: 'hk 2/28/2018 13:04'!
boot02
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Alster' ;	
		Bootstyp: 'Zweier';
		MannschaftAnzahlMax: 3;	
		Steuermann: 'mit';
		Baujahr: 1964;
		yourself

! !

!Boote methodsFor: 'test data' stamp: 'hk 2/28/2018 13:04'!
boot03
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Elbe' ;	
		Bootstyp: 'Zweier';
		MannschaftAnzahlMax: 2;	
		Steuermann: 'ohne';
		Baujahr: 1980;
		yourself! !

!Boote methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:02'!
bootContext
	^ '
plain BootContext {
	displayAs	: Boot
	icon	: rowingBoat
	uiSpec	: GbtItemUI
	}
	'
! !

!Boote methodsFor: 'contexts' stamp: 'hk 2/28/2018 13:03'!
booteContext
	^ '
primeList BooteContext of Boot{
	displayAs		: Boote
	icon			: rowingBoat
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (Bootsname Boot)(Bootstyp Typ) Steuermann 
	listPrefix	: Boot
	subcontext	: BootContext
	}
	'
! !

!Boote methodsFor: 'test data' stamp: 'hk 10/17/2017 16:32'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #BooteContext! !

!Boote methodsFor: 'functions' stamp: 'hk 1/27/2018 16:50'!
projectors
 	^''! !

!Boote methodsFor: 'test data' stamp: 'hk 12/31/2017 19:12'!
storeBoote
	self boot01 storeSubtree.
	self boot02 storeSubtree.
	self boot03 storeSubtree! !

!Boote methodsFor: 'things' stamp: 'hk 2/28/2018 13:02'!
things
	^ '	
thing Boot
	summary	: #Bootsname
	bizIdPolicy	: BootNoPolicy
	{
	*val Bootstyp	: Einer | Zweier | Dreier | Vierer | Fünfer | Achter {ui: GbtChoiceWidget}
	*val Bootsname	: 
	*val MannschaftAnzahlMax	: 1
	val Steuermann	: mit | ohne {ui: GbtChoiceWidget}
	val Baujahr	: 
	}
'! !

Stammdaten subclass: #FahrtenabzeichenStammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Personen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Personen class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:13'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		storePersonen ;
		personenContext) ui 
			title: #Personen; 
			open! !

!Personen methodsFor: 'test data' stamp: 'hk 10/18/2017 17:15'!
eMail
	^GbtSmartNode copy: 'EMail'! !

!Personen methodsFor: 'test data' stamp: 'hk 10/17/2017 17:41'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #PersonenContext
! !

!Personen methodsFor: 'test data' stamp: 'hk 10/17/2017 17:43'!
person
	^GbtSmartNode copy: 'Person'! !

!Personen methodsFor: 'test data' stamp: 'hk 11/9/2017 11:07'!
person01
	| tmp1 tmp2 tmp3 tmp4 tmp5 tmp7 tmp9 |
	tmp2 := self person.
	tmp1 := tmp2 mitglied.
	tmp1
		GebDatum: '08.06.1954';
		Mitgliedstatus: #aktiv;
		Beitragstatus: #Erwachsener;
		FamilienOberhaupt: #true;
		FamilienmitgliedNr: 1;
		MitgliedSeit: '01.01.1967';
		Familienname: #Schmidt;
		BeitragsSonderregelung: #false;
		Abrechnungsperiode: #jährlich;
		Beruf: 'Kaufmann';
		Familienname: 'Schmidt'.
	tmp7 := tmp1 KontoDaten.
	tmp7
		IBAN: 'DE1234567890';
		BIC: 'XYZABC'.
	tmp2
		Nachname: #Schmidt;
		Vorname: #Henning.
	tmp9 := tmp2 Kontaktdaten.
	tmp9
		StraßeUndNummer: 'Rethfelder Str 48';
		PLZUndWohnort: '25336 Elmshorn'.
	tmp3 := tmp2 Kommunikation.
	tmp4 := self telNo.
	tmp4 TelNr: '04121 48831'.
	tmp3 newEntry: tmp4 yourself with: 'Privat'.
	tmp5 := self eMail.
	tmp5 EMail: 'schmidt@gmail.com'.
	tmp3 newEntry: tmp5 yourself with: 'Privat'.
	^ tmp2! !

!Personen methodsFor: 'test data' stamp: 'hk 11/8/2017 16:59'!
person02
	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.07.1961' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 2.	
	m MitgliedSeit: '01.15.1993'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Buchhändlerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	
	p Nachname: #Schmidt .
	p Vorname: #Christel.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	p Kommunikation 
		newEntry: ( self telNo TelNr: '04121 48832'; yourself)  with: 'Privat';
		newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen methodsFor: 'test data' stamp: 'hk 11/8/2017 16:58'!
person03
	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '03.10.1996' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Nichtverdiener14plus .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 3.	
	m MitgliedSeit: '01.01.2007'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Schülerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	
	p Nachname: #Schmidt .
	p Vorname: #Imke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	p Kommunikation 
		newEntry: ( self telNo TelNr: '04121 48833'; yourself)  with: 'Privat';
		newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen methodsFor: 'test data' stamp: 'hk 11/8/2017 16:58'!
person04
	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.10.1989' .	
	m Mitgliedstatus: #passiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 4.	
	m MitgliedSeit: '01.01.2000'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Sozialpädagogin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	
	p Nachname: #Schmidt .
	p Vorname: #Levke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	p Kommunikation 
		newEntry: ( self telNo TelNr: '04121 48834'; yourself)  with: 'Privat';
		newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:01'!
personContext
	^ '	
plain PersonContext {
	displayAs		: Person
	icon			: rower
	uiSpec			: GbtItemUI
	}
 '! !

!Personen methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:01'!
personenContext
	^ '	
primeList PersonenContext of Person{
	displayAs		: Personen
	icon			: rower
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (Nachname Name)(Vorname Vorname)
	listPrefix	: Sportler
	subcontext	: PersonContext
	}
 '! !

!Personen methodsFor: 'functions' stamp: 'hk 1/27/2018 16:50'!
projectors
 	^''! !

!Personen methodsFor: 'test data' stamp: 'hk 12/31/2017 19:12'!
storePersonen
	| person |
	1 to: 10 do: [ :index | 
		person := self person01 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ].
	1 to: 1 do: [ :index | 
		person := self person02 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ].
	1 to: 1 do: [ :index | 
		person := self person03 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ].
	1 to: 1 do: [ :index | 
		person := self person04 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ]! !

!Personen methodsFor: 'test data' stamp: 'hk 10/18/2017 17:15'!
telNo
	^GbtSmartNode copy: 'TelNo'! !

!Personen methodsFor: 'things' stamp: 'hk 2/25/2018 13:10'!
things
	^ '	thing Person 
		summary 						: ''#Vorname #Nachname''
		bizIdPolicy 					: SportlerNoPolicy
		{ 
		*val Nachname 				:  
		*val Vorname 				:  
		*val Vorname2 				:  
		node Kontaktdaten 			: Kontaktdaten
		node Sportler 				: Sportlerdaten
		node mitglied 	 			: Mitglied
		}
	thing Mitglied
		summary 						: ''#Mitgliedstatus #Beitragstatus''
		bizIdPolicy 					: MitgliedNoPolicy
		{ 
		*val GebDatum 				: date(today)
		*val Mitgliedstatus 		: aktiv | passiv {ui: GbtChoiceWidget}
		*val Beitragstatus 		: Erwachsener | Nichtverdiener14+ | Kind14- {ui: GbtChoiceWidget}
		*val FamilienOberhaupt 	: false | true {ui: GbtChoiceWidget}
		*val FamilienmitgliedNr 	: 1
		*val MitgliedSeit 		: date(today) 
		val Beruf						: 
		val Familienname 			:
		val FamilienNummer 		: bizId Oberhaupt 
		val Familienmitglieder 	: {ui: GbtChoiceWidget}
		val FahrtenabzeichenStatus : M18max | W18max | M18plus | W18plus {ui: GbtChoiceWidget}
		val Schnuppermitglied 	: false | true {ui: GbtChoiceWidget}
		val Austrittserklärung 	: date(today) 
		val Austritt 				: ''if(#Austrittserklärung !!= nil , (if(#Schnuppermitglied, date+m(#MitgliedSeit,3) , silvester(today)''
		node KontoDaten 			: KontoDaten
		list Beitragsrechnung 	: Rechnung
		val BeitragsSonderregelung : false | true {ui: GbtChoiceWidget}
		val Abrechnungsperiode 	: jährlich | halbjährlich | monatlich | sonstiges {ui: GbtChoiceWidget}
		}				
	thing Sportlerdaten
		summary 						: system template
		{  
		*val Fremdverein			:  
		*text Bemerkungen 			:  
		}
	thing TelNo
		summary 						: ''#TelNr''
		purposes 						: mobileprivat mobilarbeit Privat Arbeit Fax 
		{  
		*val TelNr					:  Telefonnummer
		}
	thing KontoDaten
		summary 						: #Kontoinhaber
		{  
		*val Kontoinhaber			: ''resolve (#Vorname #Nachname)''
		*val IBAN 					:
		*val BIC 						:
		}
	thing Kontaktdaten
		summary 						: EMail: #EMail Tel: #telNo
		{  
		val StraßeUndNummer		:  
		val PLZUndWohnort 			:
		list Kommunikation 		: TelNo EMail
		}
	thing EMail
		summary 						: #EMail 
		purposes 						: Privat Arbeit
		{  
		*val EMail					:  EMail
		}
'! !

EFA subclass: #Statistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Statistics class methodsFor: 'example' stamp: 'hk 11/8/2017 15:13'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation;
		statisticsContext ) ui 
			title: #Statistiken; 
			open! !

!Statistics methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:00'!
ergebnisContext
^'
plain ErgebnisContext {
	displayAs	: Ergebnis
	icon	: statistics 
	uiSpec	: GbtItemUI 
	}
'! !

!Statistics methodsFor: 'contexts' stamp: 'hk 1/24/2018 17:00'!
ergebnisseContext
^'
uList ErgebnisseContext  of Ergebnis {
	displayAs	: Ergebnisse
	icon	: statistics
	uiSpec	: GbtListAndItemUI
	listColumns	: Kilometer Abfahrt Ankunft Ziel Bootsname RudererName  
	subcontext	: ErgebnisContext
	elderSlot	: resultList
	}
'! !

!Statistics methodsFor: 'functions' stamp: 'hk 1/27/2018 17:23'!
projectors
	^'
projector DirBootsname {
	tag Bootsname 	: boot
	}
projector DirRuderername {
	tag Nachname 	: ruderer
	}
'! !

!Statistics methodsFor: 'contexts' stamp: 'hk 1/28/2018 14:47'!
statisticContext
^'
plain StatisticContext {
	displayAs	: Statistik
	icon	: statistics
	uiSpec	: GbtItemWithTabsUI
	pool	: Ergebnis ErgebnisDir
	subcontexts	: ErgebnisseContext 
	menu	: kmStatistik 
	behaviors	: kmStatistik
	}
behavior kmStatistik 
	arg1 				:  contextThing 	% the default
	{ 
	fahrten 			:  FahrtenBuchContext:list 
	constraint 		:  arg1:constraints
	selected			:  filter(fahrten constraint) 									
	kmStatistik 		:  arg1:resultList := nodeList(selected)
	}
'! !

!Statistics methodsFor: 'compile' stamp: 'hk 1/27/2018 16:37'!
statisticsContext 
	^GbtSmartContext definedAs: 'StatisticsContext' ! !

!Statistics methodsFor: 'contexts' stamp: 'hk 1/29/2018 13:39'!
statisticsContexts
^'
primeList StatisticsContext  of kmStatisticBoote kmStatisticRuderer kmStatistic {
	displayAs	: Statistiken
	icon	: statistics
	uiSpec	: GbtListAndItemUI
	pool	: DirBootsname DirRuderername
	loadPolicy	: simpleload
	listColumns	: km ruderer boot datum begin end  
	listPrefix	: Stat
	subcontext	: StatisticContext
	menu	: Run BooteStatistik RudererStatistik
	behaviors	: BooteStatistik RudererStatistik
	}
behavior BooteStatistik {  
	statistik 		: kmStatisticBoote
	startListName 	: statistik:startList
	startListe 		: contextList (startListName)
	statistiken 		: projectOnto (DirBootsname startListe statistik)
	behavior 			: StatisticContext:kmStatistik
	resultListe 		: applyOnList (behavior statistiken)
	BooteStatistik 	: appendBL (StatisticsContext resultListe) 	
	}
behavior RudererStatistik {  
	statistik 		: kmStatisticRuderer
	startListName 	: statistik:startList
	startListe 		: contextList (startListName)
	statistiken 		: projectOnto ( DirRuderername startListe statistik)
	behavior 			: StatisticContext:kmStatistik
	resultListe 		: applyOnList (behavior statistiken)
	RudererStatistik : appendBL (StatisticsContext resultListe) 	
	}
'! !

!Statistics methodsFor: 'things' stamp: 'hk 2/27/2018 17:16'!
things
	^'
thing Ergebnis
	summary	: km-Statistik
	{
	*val FahrtID	: 
	*val Datum	: date(today)
	*val Bootsname	: 
	*val RudererName	: 
	*val Kilometer	: 
	*val Abfahrt	: date(today)
	*val Ankunft	: date(today)
	*val Ziel	: 
	}
thing FahrtenConstraint
	{
	*val begin	: date(1.1.2016)
	*val end	: date(12.31.2016)
	*constraint gtBegin	: #Abfahrt > #begin
	*constraint ltEnd	: #Ankunft < #end
	*val boot	: 
	*constraint welches	: #Bootsname = #boot
	*val ruderer	: 
	*constraint wer	: #RudererName = #ruderer
	}
thing kmStatistic
	summary	: km-Statistik
	bizIdPolicy	: StatistikNoPolicy
	{
	*val datum	: date (today)
	*val km	: sumTag (Kilometer)
	*val startList	: BooteContext {ui: GbtChoiceWidget}
	*list resultList	: Ergebnis 
	*node constraints	: FahrtenConstraint
	}
thing BooteConstraint
	{
	*val begin	: date(1.1.2016)
	*val end	: date(12.31.2016)
	*constraint gtBegin	: #Abfahrt > #begin
	*constraint ltEnd	: #Ankunft < #end
	*val boot	: 
	*constraint welches	: #Bootsname = #boot
	}
thing kmStatisticBoote
	summary	: Boote-Statistik
	bizIdPolicy	: StatistikNoPolicy
	{
	*val datum	: date (today)
	*val km	: sumTag (Kilometer)
	*val startList	: BooteContext {ui: GbtChoiceWidget}
	*list resultList	: kmStatistic      % overwritten by NodeListAC  
	*node constraints	: BooteConstraint
	}
thing RudererConstraint
	{
	*val begin	: date(1.1.2016)
	*val end	: date(12.31.2016)
	*constraint gtBegin	: #Abfahrt > #begin
	*constraint ltEnd	: #Ankunft < #end
	*val ruderer	: 
	*constraint wer	: #RudererName = #ruderer
	}
thing kmStatisticRuderer
	summary	: Ruderer-Statistik
	bizIdPolicy	: StatistikNoPolicy
	{
	*val datum	: date (today)
	*val km	: sumTag (Kilometer)
	*val startList	: PersonenContext {ui: GbtChoiceWidget}
	*list resultList	: Ergebnis 
	*node constraints	: RudererConstraint
	}
'! !
